Index: code/branches/pickupsFS14/src/modules/jump/JumpPlatformHMove.cc
===================================================================
--- code/branches/pickupsFS14/src/modules/jump/JumpPlatformHMove.cc	(revision 10050)
+++ code/branches/pickupsFS14/src/modules/jump/JumpPlatformHMove.cc	(revision 10050)
@@ -0,0 +1,120 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+    @file JumpPlatformHMove.cc
+    @brief Implementation of the JumpPlatform class.
+*/
+
+#include "JumpPlatformHMove.h"
+
+#include "core/CoreIncludes.h"
+#include "core/GameMode.h"
+
+#include "gametypes/Gametype.h"
+
+#include "JumpFigure.h"
+
+#include "sound/WorldSound.h"
+#include "core/XMLPort.h"
+
+#include "graphics/Backlight.h"
+
+namespace orxonox
+{
+    RegisterClass(JumpPlatformHMove);
+
+    /**
+    @brief
+        Constructor. Registers and initializes the object.
+    */
+    JumpPlatformHMove::JumpPlatformHMove(Context* context) : JumpPlatform(context)
+    {
+        RegisterObject(JumpPlatformHMove);
+
+        setProperties(-100,100,5);
+    }
+
+    /**
+    @brief
+        Destructor.
+    */
+    JumpPlatformHMove::~JumpPlatformHMove()
+    {
+
+    }
+
+    //xml port for loading sounds
+    void JumpPlatformHMove::XMLPort(Element& xmlelement, XMLPort::Mode mode)
+    {
+        SUPER(JumpPlatformHMove, XMLPort, xmlelement, mode);
+    }
+
+    /**
+    @brief
+        Is called every tick.
+        Handles the movement of the ball and its interaction with the boundaries and bats.
+    @param dt
+        The time since the last tick.
+    */
+    void JumpPlatformHMove::tick(float dt)
+    {
+        SUPER(JumpPlatformHMove, tick, dt);
+
+        // Get the current position, velocity and acceleration of the ball.
+        Vector3 position = this->getPosition();
+        Vector3 velocity = this->getVelocity();
+
+        if ((position.x < leftBoundary_ && velocity.x < 0) || (position.x > rightBoundary_ && velocity.x > 0))
+
+        {
+        	//orxout() << "refelected platformHMove at " << position.x << endl;
+        	velocity.x = -velocity.x;
+        }
+
+        // Set the position, velocity and acceleration of the ball, if they have changed.
+        if (velocity != this->getVelocity())
+            this->setVelocity(velocity);
+        if (position != this->getPosition())
+            this->setPosition(position);
+    }
+
+    void JumpPlatformHMove::setProperties(float leftBoundary, float rightBoundary, float speed)
+    {
+    	leftBoundary_ = leftBoundary;
+    	rightBoundary_ = rightBoundary;
+
+        this->setVelocity(Vector3(speed,0,0));
+
+    }
+
+    void JumpPlatformHMove::touchFigure()
+    {
+    	accelerateFigure();
+    }
+}
Index: code/branches/pickupsFS14/src/modules/jump/JumpPlatformHMove.h
===================================================================
--- code/branches/pickupsFS14/src/modules/jump/JumpPlatformHMove.h	(revision 10050)
+++ code/branches/pickupsFS14/src/modules/jump/JumpPlatformHMove.h	(revision 10050)
@@ -0,0 +1,77 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+    @file JumpPlatformHMove.h
+    @brief Declaration of the JumpPlatform class.
+    @ingroup Jump
+*/
+
+#ifndef _JumpPlatformHMove_H__
+#define _JumpPlatformHMove_H__
+
+#include "jump/JumpPrereqs.h"
+
+#include "util/Math.h"
+
+#include "worldentities/MovableEntity.h"
+
+
+namespace orxonox
+{
+
+    /**
+    @brief
+        This class manages the ball for @ref orxonox::Jump "Jump".
+
+        It is responsible for both the movement of the ball in the x,z-plane as well as its interaction with the boundaries of the playing field (defined by the @ref orxonox::JumpCenterpoint "JumpCenterpoint") and the @ref orxonox::JumpFigure "JumpFigures". Or more precisely, it makes the ball bounce off then upper and lower delimiters of the playing field, it makes the ball bounce off the bats and also detects when a player scores and takes appropriate measures.
+
+    @author
+        Fabian 'x3n' Landau
+
+    @ingroup Jump
+    */
+    class _JumpExport JumpPlatformHMove : public JumpPlatform
+    {
+        public:
+    	    JumpPlatformHMove(Context* context);
+            virtual ~JumpPlatformHMove();
+
+            virtual void tick(float dt);
+            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
+
+            virtual void setProperties(float leftBoundary, float rightBoundary, float speed);
+            virtual void touchFigure();
+
+        protected:
+            float leftBoundary_;
+            float rightBoundary_;
+    };
+}
+
+#endif /* _JumpPlatform_H__ */
Index: code/branches/pickupsFS14/src/modules/jump/JumpPlatformStatic.cc
===================================================================
--- code/branches/pickupsFS14/src/modules/jump/JumpPlatformStatic.cc	(revision 10050)
+++ code/branches/pickupsFS14/src/modules/jump/JumpPlatformStatic.cc	(revision 10050)
@@ -0,0 +1,91 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+    @file JumpPlatformStatic.cc
+    @brief Implementation of the JumpPlatformStatic class.
+*/
+
+#include "JumpPlatformStatic.h"
+
+#include "core/CoreIncludes.h"
+#include "core/GameMode.h"
+
+#include "gametypes/Gametype.h"
+
+#include "JumpFigure.h"
+
+#include "sound/WorldSound.h"
+#include "core/XMLPort.h"
+
+namespace orxonox
+{
+    RegisterClass(JumpPlatformStatic);
+
+    /**
+    @brief
+        Constructor. Registers and initializes the object.
+    */
+    JumpPlatformStatic::JumpPlatformStatic(Context* context) : JumpPlatform(context)
+    {
+        RegisterObject(JumpPlatformStatic);
+
+    }
+
+    /**
+    @brief
+        Destructor.
+    */
+    JumpPlatformStatic::~JumpPlatformStatic()
+    {
+
+    }
+
+    //xml port for loading sounds
+    void JumpPlatformStatic::XMLPort(Element& xmlelement, XMLPort::Mode mode)
+    {
+        SUPER(JumpPlatformStatic, XMLPort, xmlelement, mode);
+    }
+
+    /**
+    @brief
+        Is called every tick.
+        Handles the movement of the ball and its interaction with the boundaries and bats.
+    @param dt
+        The time since the last tick.
+    */
+    void JumpPlatformStatic::tick(float dt)
+    {
+        SUPER(JumpPlatformStatic, tick, dt);
+    }
+
+    void JumpPlatformStatic::touchFigure()
+    {
+    	accelerateFigure();
+    }
+}
Index: code/branches/pickupsFS14/src/modules/jump/JumpPlatformStatic.h
===================================================================
--- code/branches/pickupsFS14/src/modules/jump/JumpPlatformStatic.h	(revision 10050)
+++ code/branches/pickupsFS14/src/modules/jump/JumpPlatformStatic.h	(revision 10050)
@@ -0,0 +1,72 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+    @file JumpPlatformStatic.h
+    @brief Declaration of the JumpPlatformStatic class.
+    @ingroup Jump
+*/
+
+#ifndef _JumpPlatformStatic_H__
+#define _JumpPlatformStatic_H__
+
+#include "jump/JumpPrereqs.h"
+
+#include "util/Math.h"
+
+#include "worldentities/MovableEntity.h"
+
+
+namespace orxonox
+{
+
+    /**
+    @brief
+        This class manages the ball for @ref orxonox::Jump "Jump".
+
+        It is responsible for both the movement of the ball in the x,z-plane as well as its interaction with the boundaries of the playing field (defined by the @ref orxonox::JumpCenterpoint "JumpCenterpoint") and the @ref orxonox::JumpFigure "JumpFigures". Or more precisely, it makes the ball bounce off then upper and lower delimiters of the playing field, it makes the ball bounce off the bats and also detects when a player scores and takes appropriate measures.
+
+    @author
+        Fabian 'x3n' Landau
+
+    @ingroup Jump
+    */
+    class _JumpExport JumpPlatformStatic : public JumpPlatform
+    {
+        public:
+    	    JumpPlatformStatic(Context* context);
+            virtual ~JumpPlatformStatic();
+
+            virtual void tick(float dt);
+            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
+
+            virtual void touchFigure();
+    };
+}
+
+#endif /* _JumpPlatform_H__ */
Index: code/branches/pickupsFS14/src/modules/jump/JumpPlatformTimer.cc
===================================================================
--- code/branches/pickupsFS14/src/modules/jump/JumpPlatformTimer.cc	(revision 10050)
+++ code/branches/pickupsFS14/src/modules/jump/JumpPlatformTimer.cc	(revision 10050)
@@ -0,0 +1,125 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+    @file JumpPlatformTimer.cc
+    @brief Implementation of the JumpPlatform class.
+*/
+
+#include "JumpPlatformTimer.h"
+
+#include "core/CoreIncludes.h"
+#include "core/GameMode.h"
+
+#include "gametypes/Gametype.h"
+
+#include "JumpFigure.h"
+
+#include "sound/WorldSound.h"
+#include "core/XMLPort.h"
+
+namespace orxonox
+{
+    RegisterClass(JumpPlatformTimer);
+
+    /**
+    @brief
+        Constructor. Registers and initializes the object.
+    */
+    JumpPlatformTimer::JumpPlatformTimer(Context* context) : JumpPlatform(context)
+    {
+        RegisterObject(JumpPlatformTimer);
+
+        particleSpawner = NULL;
+
+        setProperties(3.0);
+
+    }
+
+    /**
+    @brief
+        Destructor.
+    */
+    JumpPlatformTimer::~JumpPlatformTimer()
+    {
+
+    }
+
+    //xml port for loading sounds
+    void JumpPlatformTimer::XMLPort(Element& xmlelement, XMLPort::Mode mode)
+    {
+        SUPER(JumpPlatformTimer, XMLPort, xmlelement, mode);
+
+        XMLPortParam(JumpPlatformTimer, "effectPath", setEffectPath, getEffectPath, xmlelement, mode);
+        XMLPortParam(JumpPlatformTimer, "effectStartTime", setEffectStartTime, getEffectStartTime, xmlelement, mode);
+    }
+
+    /**
+    @brief
+        Is called every tick.
+        Handles the movement of the ball and its interaction with the boundaries and bats.
+    @param dt
+        The time since the last tick.
+    */
+    void JumpPlatformTimer::tick(float dt)
+    {
+        SUPER(JumpPlatformTimer, tick, dt);
+
+        time_ -= dt;
+        if (time_ < effectStartTime_ && particleSpawner == NULL)
+        {
+
+        	particleSpawner = new ParticleSpawner(getContext());
+        	particleSpawner->setSource(effectPath_);
+            particleSpawner->setLoop(false);
+            particleSpawner->setLOD(LODParticle::Low);
+            particleSpawner->setLifetime(effectStartTime_);
+
+            attach(particleSpawner);
+        }
+    }
+
+    void JumpPlatformTimer::setProperties(float time)
+    {
+    	time_ = time;
+    }
+
+    bool JumpPlatformTimer::isActive(void)
+    {
+    	return time_ > 0.0;
+    }
+
+    void JumpPlatformTimer::touchFigure()
+    {
+    	accelerateFigure();
+    	if (isActive())
+    	{
+    		accelerateFigure();
+    	}
+    }
+}
Index: code/branches/pickupsFS14/src/modules/jump/JumpPlatformTimer.h
===================================================================
--- code/branches/pickupsFS14/src/modules/jump/JumpPlatformTimer.h	(revision 10050)
+++ code/branches/pickupsFS14/src/modules/jump/JumpPlatformTimer.h	(revision 10050)
@@ -0,0 +1,93 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+    @file JumpPlatformTimer.h
+    @brief Declaration of the JumpPlatformTimer class.
+    @ingroup Jump
+*/
+
+#ifndef _JumpPlatformTimer_H__
+#define _JumpPlatformTimer_H__
+
+#include "jump/JumpPrereqs.h"
+
+#include "util/Math.h"
+
+#include "worldentities/MovableEntity.h"
+#include "graphics/ParticleSpawner.h"
+
+
+namespace orxonox
+{
+
+    /**
+    @brief
+        This class manages the ball for @ref orxonox::Jump "Jump".
+
+        It is responsible for both the movement of the ball in the x,z-plane as well as its interaction with the boundaries of the playing field (defined by the @ref orxonox::JumpCenterpoint "JumpCenterpoint") and the @ref orxonox::JumpFigure "JumpFigures". Or more precisely, it makes the ball bounce off then upper and lower delimiters of the playing field, it makes the ball bounce off the bats and also detects when a player scores and takes appropriate measures.
+
+    @author
+        Fabian 'x3n' Landau
+
+    @ingroup Jump
+    */
+    class _JumpExport JumpPlatformTimer : public JumpPlatform
+    {
+        public:
+    	    JumpPlatformTimer(Context* context);
+            virtual ~JumpPlatformTimer();
+
+            virtual void tick(float dt);
+            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
+
+            virtual void setProperties(float time);
+            virtual bool isActive(void);
+            virtual void touchFigure();
+
+            void setEffectPath(const std::string& effectPath)
+                { this->effectPath_ = effectPath; }
+
+            const std::string& getEffectPath() const
+                { return this->effectPath_; }
+
+            void setEffectStartTime(const float effectStartTime)
+                { this->effectStartTime_ = effectStartTime; }
+
+            const float getEffectStartTime() const
+                { return this->effectStartTime_; }
+
+        protected:
+            float time_;
+            ParticleSpawner* particleSpawner;
+            std::string effectPath_;
+            float effectStartTime_;
+    };
+}
+
+#endif /* _JumpPlatformTimer_H__ */
Index: code/branches/pickupsFS14/src/modules/jump/JumpPlatformVMove.cc
===================================================================
--- code/branches/pickupsFS14/src/modules/jump/JumpPlatformVMove.cc	(revision 10050)
+++ code/branches/pickupsFS14/src/modules/jump/JumpPlatformVMove.cc	(revision 10050)
@@ -0,0 +1,117 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+    @file JumpPlatformVMove.cc
+    @brief Implementation of the JumpPlatform class.
+*/
+
+#include "JumpPlatformVMove.h"
+
+#include "core/CoreIncludes.h"
+#include "core/GameMode.h"
+
+#include "gametypes/Gametype.h"
+
+#include "JumpFigure.h"
+
+#include "sound/WorldSound.h"
+#include "core/XMLPort.h"
+
+namespace orxonox
+{
+    RegisterClass(JumpPlatformVMove);
+
+    /**
+    @brief
+        Constructor. Registers and initializes the object.
+    */
+    JumpPlatformVMove::JumpPlatformVMove(Context* context) : JumpPlatform(context)
+    {
+        RegisterObject(JumpPlatformVMove);
+
+        setProperties(0,80,10);
+    }
+
+    /**
+    @brief
+        Destructor.
+    */
+    JumpPlatformVMove::~JumpPlatformVMove()
+    {
+
+    }
+
+    //xml port for loading sounds
+    void JumpPlatformVMove::XMLPort(Element& xmlelement, XMLPort::Mode mode)
+    {
+        SUPER(JumpPlatformVMove, XMLPort, xmlelement, mode);
+    }
+
+    /**
+    @brief
+        Is called every tick.
+        Handles the movement of the ball and its interaction with the boundaries and bats.
+    @param dt
+        The time since the last tick.
+    */
+    void JumpPlatformVMove::tick(float dt)
+    {
+        SUPER(JumpPlatformVMove, tick, dt);
+
+        // Get the current position, velocity and acceleration of the ball.
+        Vector3 position = this->getPosition();
+        Vector3 velocity = this->getVelocity();
+
+        if ((position.z < lowerBoundary_ && velocity.z < 0) || (position.z > upperBoundary_ && velocity.z > 0))
+        {
+        	//orxout() << "refelected platformVMove at " << position.z << endl;
+        	velocity.z = -velocity.z;
+        }
+
+        // Set the position, velocity and acceleration of the ball, if they have changed.
+        if (velocity != this->getVelocity())
+            this->setVelocity(velocity);
+        if (position != this->getPosition())
+            this->setPosition(position);
+    }
+
+    void JumpPlatformVMove::setProperties(float lowerBoundary, float upperBoundary, float speed)
+    {
+    	lowerBoundary_ = lowerBoundary;
+    	upperBoundary_ = upperBoundary;
+
+        this->setVelocity(Vector3(0,0,speed));
+
+    }
+
+    void JumpPlatformVMove::touchFigure()
+    {
+    	accelerateFigure();
+    }
+}
Index: code/branches/pickupsFS14/src/modules/jump/JumpPlatformVMove.h
===================================================================
--- code/branches/pickupsFS14/src/modules/jump/JumpPlatformVMove.h	(revision 10050)
+++ code/branches/pickupsFS14/src/modules/jump/JumpPlatformVMove.h	(revision 10050)
@@ -0,0 +1,77 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+    @file JumpPlatformVMove.h
+    @brief Declaration of the JumpPlatform class.
+    @ingroup Jump
+*/
+
+#ifndef _JumpPlatformVMove_H__
+#define _JumpPlatformVMove_H__
+
+#include "jump/JumpPrereqs.h"
+
+#include "util/Math.h"
+
+#include "worldentities/MovableEntity.h"
+
+
+namespace orxonox
+{
+
+    /**
+    @brief
+        This class manages the ball for @ref orxonox::Jump "Jump".
+
+        It is responsible for both the movement of the ball in the x,z-plane as well as its interaction with the boundaries of the playing field (defined by the @ref orxonox::JumpCenterpoint "JumpCenterpoint") and the @ref orxonox::JumpFigure "JumpFigures". Or more precisely, it makes the ball bounce off then upper and lower delimiters of the playing field, it makes the ball bounce off the bats and also detects when a player scores and takes appropriate measures.
+
+    @author
+        Fabian 'x3n' Landau
+
+    @ingroup Jump
+    */
+    class _JumpExport JumpPlatformVMove : public JumpPlatform
+    {
+        public:
+    	    JumpPlatformVMove(Context* context);
+            virtual ~JumpPlatformVMove();
+
+            virtual void tick(float dt);
+            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
+
+            virtual void setProperties(float leftBoundary, float rightBoundary, float speed);
+            virtual void touchFigure();
+
+        protected:
+            float lowerBoundary_;
+            float upperBoundary_;
+    };
+}
+
+#endif /* _JumpPlatform_H__ */
Index: code/branches/pickupsFS14/src/modules/jump/JumpPrereqs.h
===================================================================
--- code/branches/pickupsFS14/src/modules/jump/JumpPrereqs.h	(revision 10041)
+++ code/branches/pickupsFS14/src/modules/jump/JumpPrereqs.h	(revision 10050)
@@ -73,4 +73,10 @@
     class JumpPlatformHMove;
     class JumpPlatformVMove;
+    class JumpPlatformDisappear;
+    class JumpPlatformTimer;
+    class JumpPlatformFake;
+    class JumpProjectile;
+    class JumpEnemy;
+    class JumpItem;
     class JumpFigure;
     class JumpCenterpoint;
Index: code/branches/pickupsFS14/src/modules/jump/JumpProjectile.cc
===================================================================
--- code/branches/pickupsFS14/src/modules/jump/JumpProjectile.cc	(revision 10050)
+++ code/branches/pickupsFS14/src/modules/jump/JumpProjectile.cc	(revision 10050)
@@ -0,0 +1,144 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+    @file JumpProjectile.cc
+    @brief Implementation of the JumpProjectile class.
+*/
+
+#include "JumpProjectile.h"
+
+#include "core/CoreIncludes.h"
+#include "core/GameMode.h"
+#include "graphics/Model.h"
+#include "gametypes/Gametype.h"
+
+#include "JumpFigure.h"
+
+#include "sound/WorldSound.h"
+#include "core/XMLPort.h"
+
+namespace orxonox
+{
+    RegisterClass(JumpProjectile);
+
+    /**
+    @brief
+        Constructor. Registers and initializes the object.
+    */
+    JumpProjectile::JumpProjectile(Context* context) : MovableEntity(context)
+    {
+        RegisterObject(JumpProjectile);
+
+        this->figure_ = 0;
+
+        this->registerVariables();
+
+        this->setPosition(Vector3(0,0,0));
+        this->setVelocity(Vector3(0,0,0));
+        this->setAcceleration(Vector3(0,0,0));
+    }
+
+    /**
+    @brief
+        Destructor.
+    */
+    JumpProjectile::~JumpProjectile()
+    {
+        /*if (this->isInitialized())
+        {
+            if (this->bDeleteBats_)
+                delete this->figure_;
+
+            delete[] this->batID_;
+        }*/
+    }
+
+    //xml port for loading sounds
+    void JumpProjectile::XMLPort(Element& xmlelement, XMLPort::Mode mode)
+    {
+        SUPER(JumpProjectile, XMLPort, xmlelement, mode);
+    }
+
+    /**
+    @brief
+        Register variables to synchronize over the network.
+    */
+    void JumpProjectile::registerVariables()
+    {
+        registerVariable( this->fieldWidth_ );
+        registerVariable( this->fieldHeight_ );
+        //registerVariable( this->batID_[1], VariableDirection::ToClient, new NetworkCallback<JumpProjectile>( this, &JumpProjectile::applyBats) );
+    }
+
+    /**
+    @brief
+        Is called every tick.
+        Handles the movement of the ball and its interaction with the boundaries and bats.
+    @param dt
+        The time since the last tick.
+    */
+    void JumpProjectile::tick(float dt)
+    {
+        SUPER(JumpProjectile, tick, dt);
+
+        Vector3 platformPosition = this->getPosition();
+
+        if (figure_ != NULL)
+        {
+            Vector3 figurePosition = figure_->getPosition();
+            Vector3 figureVelocity = figure_->getVelocity();
+
+            if(figureVelocity.z < 0 && figurePosition.x > platformPosition.x-10 && figurePosition.x < platformPosition.x+10 && figurePosition.z > platformPosition.z-4 && figurePosition.z < platformPosition.z+4)
+            {
+            	touchFigure();
+            }
+        }
+    }
+
+    /**
+    @brief
+        Set the bats for the ball.
+    @param bats
+        An array (of size 2) of weak pointers, to be set as the new bats.
+    */
+    void JumpProjectile::setFigure(WeakPtr<JumpFigure> newFigure)
+    {
+        figure_ = newFigure;
+    }
+
+    void JumpProjectile::accelerateFigure()
+    {
+
+    }
+
+    void JumpProjectile::touchFigure()
+    {
+
+    }
+}
